#include<bits/stdc++.h>
using namespace std;
vector <pair<pair<int,int>,pair<char,int>>> prvi;
vector <pair<pair<int,int>,int>> drugi;
vector <int> v[1002];
bool posecen[1002];
int dfs(int x, int y)
{
    posecen[x]=true;
    int vrati=0;
    for(auto a: v[x])
    {
        if(a==y)
            vrati++;
        else if(!posecen[a])
            vrati+=dfs(a,y);
    }
    return vrati;
}
int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n,q;
    cin>>n>>q;
    bool susedni=true;
    bool samoa=true;
    for(int i=0; i<q; i++)
    {
        int vrsta;
        cin>>vrsta;
        if(vrsta==1)
        {
            int x,y;
            char c;
            cin>>x>>y>>c;
            prvi.push_back({{x,y},{c,i}});
            if(c!='a')
                samoa=false;
            if(x-y!=1||y-x!=1)
                susedni=false;
        }
        else if(vrsta==2)
        {
            int x,y;
            cin>>x>>y;
            drugi.push_back({{x,y},i});
        }
    }
    if (susedni)
    {

    }
    else if(samoa)
    {
        int p1=0;
        int p2=0;
        for(int i=0; i<q; i++)
        {
            if(prvi.size()>p1&&prvi[p1].second.second==i)
            {
                int x=prvi[p1].first.first;
                int y=prvi[p1].first.second;
                char c=prvi[p1].second.first;
                v[x].push_back(y);
                v[y].push_back(x);
                p1++;
            }
            else if(drugi.size()>p2&&drugi[p2].second==i)
            {
                int x=drugi[p2].first.first;
                int y=drugi[p2].first.second;
                if(dfs(x,y)>0)
                    cout<<1<<'\n';
                else cout<<0<<'\n';
                p2++;
                for(int i=1; i<=n; i++)
                    posecen[i]=false;
            }
        }
    }
    return 0;
}